Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4576)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4577)
@@ -1670,4 +1685,14 @@
     REAL(wp),     POINTER, CONTIGUOUS, DIMENSION(:,:,:)              ::  values_realwp_3d_pointer   !< pointer to resortet array
 
+    REAL(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:)                  ::  values_real32_1d_resorted  !< resorted output variable
+    REAL(KIND=8), TARGET, ALLOCATABLE, DIMENSION(:)                  ::  values_real64_1d_resorted  !< resorted output variable
+    REAL(wp),     TARGET, ALLOCATABLE, DIMENSION(:)                  ::  values_realwp_1d_resorted  !< resorted output variable
+    REAL(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:,:)                ::  values_real32_2d_resorted  !< resorted output variable
+    REAL(KIND=8), TARGET, ALLOCATABLE, DIMENSION(:,:)                ::  values_real64_2d_resorted  !< resorted output variable
+    REAL(wp),     TARGET, ALLOCATABLE, DIMENSION(:,:)                ::  values_realwp_2d_resorted  !< resorted output variable
+    REAL(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:,:,:)              ::  values_real32_3d_resorted  !< resorted output variable
+    REAL(KIND=8), TARGET, ALLOCATABLE, DIMENSION(:,:,:)              ::  values_real64_3d_resorted  !< resorted output variable
+    REAL(wp),     TARGET, ALLOCATABLE, DIMENSION(:,:,:)              ::  values_realwp_3d_resorted  !< resorted output variable
+
     TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimension_list  !< list of used dimensions of variable
 
@@ -1676,9 +1701,9 @@
     output_return_value = 0
 
-    CALL internal_message( 'debug', routine_name // ': write ' // TRIM( variable_name ) // &
+    CALL internal_message( 'debug', routine_name // ': write ' // TRIM( variable_name ) //         &
                            ' into file ' // TRIM( file_name ) )
 !
 !-- Search for variable within file
-    CALL find_var_in_file( file_name, variable_name, file_format, file_id, variable_id, &
+    CALL find_var_in_file( file_name, variable_name, file_format, file_id, variable_id,            &
                            is_global, dimension_list, return_value=return_value  )
 
@@ -1686,11 +1711,11 @@
 !
 !--    Check if the correct amount of variable bounds were given
-       IF ( SIZE( bounds_start ) /= SIZE( dimension_list )  .OR.  &
-            SIZE( bounds_end ) /= SIZE( dimension_list ) )  THEN
+       IF ( SIZE( bounds_start ) /= SIZE( dimension_list )  .OR.                                   &
+            SIZE( bounds_end )   /= SIZE( dimension_list ) )  THEN
           return_value = 1
-          CALL internal_message( 'error', routine_name //                  &
-                                 ': number bounds do not match with ' //   &
-                                 'number of dimensions of variable ' //    &
-                                 '(variable "' // TRIM( variable_name ) // &
+          CALL internal_message( 'error', routine_name //                                          &
+                                 ': number bounds do not match with ' //                           &
+                                 'number of dimensions of variable ' //                            &
+                                 '(variable "' // TRIM( variable_name ) //                         &
                                  '", file "' // TRIM( file_name ) // '")!' )
        ENDIF
@@ -1706,30 +1731,29 @@
 
        WRITE( temp_string, * ) bounds_start
-       CALL internal_message( 'debug', routine_name //                    &
-                              ': file "' // TRIM( file_name ) //          &
-                              '", variable "' // TRIM( variable_name ) // &
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': file "' // TRIM( file_name ) //                                   &
+                              '", variable "' // TRIM( variable_name ) //                          &
                               '", bounds_start =' // TRIM( temp_string ) )
        WRITE( temp_string, * ) bounds_end
-       CALL internal_message( 'debug', routine_name //                    &
-                              ': file "' // TRIM( file_name ) //          &
-                              '", variable "' // TRIM( variable_name ) // &
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': file "' // TRIM( file_name ) //                                   &
+                              '", variable "' // TRIM( variable_name ) //                          &
                               '", bounds_end =' // TRIM( temp_string ) )
 !
 !--    Get bounds for masking
-       CALL get_masked_indices_and_masked_dimension_bounds( dimension_list,                  &
-               bounds_start, bounds_end, bounds_start_internal, value_counts, bounds_origin, &
-               masked_indices )
+       CALL get_masked_indices_and_masked_dimension_bounds( dimension_list, bounds_start,          &
+               bounds_end, bounds_start_internal, value_counts, bounds_origin, masked_indices )
 
        do_output = .NOT. ANY( value_counts == 0 )
 
        WRITE( temp_string, * ) bounds_start_internal
-       CALL internal_message( 'debug', routine_name //                    &
-                              ': file "' // TRIM( file_name ) //          &
-                              '", variable "' // TRIM( variable_name ) // &
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': file "' // TRIM( file_name ) //                                   &
+                              '", variable "' // TRIM( variable_name ) //                          &
                               '", bounds_start_internal =' // TRIM( temp_string ) )
        WRITE( temp_string, * ) value_counts
-       CALL internal_message( 'debug', routine_name //                    &
-                              ': file "' // TRIM( file_name ) //          &
-                              '", variable "' // TRIM( variable_name ) // &
+       CALL internal_message( 'debug', routine_name //                                             &
+                              ': file "' // TRIM( file_name ) //                                   &
+                              '", variable "' // TRIM( variable_name ) //                          &
                               '", value_counts =' // TRIM( temp_string ) )
 !
@@ -1754,12 +1778,11 @@
        ELSEIF ( PRESENT( values_char_2d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_char_2d_resorted(0:value_counts(1)-1, &
-                                               0:value_counts(2)-1) )
+             ALLOCATE( values_char_2d_resorted(0:value_counts(1)-1,0:value_counts(2)-1) )
              !$OMP PARALLEL PRIVATE (i,j)
              !$OMP DO
              DO  i = 0, value_counts(1) - 1
                 DO  j = 0, value_counts(2) - 1
-                   values_char_2d_resorted(i,j) = values_char_2d(masked_indices(2,j), &
-                                                                 masked_indices(1,i)  )
+                   values_char_2d_resorted(i,j) = values_char_2d(masked_indices(2,j),              &
+                                                                 masked_indices(1,i))
                 ENDDO
              ENDDO
@@ -1772,6 +1795,6 @@
        ELSEIF ( PRESENT( values_char_3d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_char_3d_resorted(0:value_counts(1)-1, &
-                                               0:value_counts(2)-1, &
+             ALLOCATE( values_char_3d_resorted(0:value_counts(1)-1,                                &
+                                               0:value_counts(2)-1,                                &
                                                0:value_counts(3)-1) )
              !$OMP PARALLEL PRIVATE (i,j,k)
@@ -1780,7 +1803,7 @@
                 DO  j = 0, value_counts(2) - 1
                    DO  k = 0, value_counts(3) - 1
-                      values_char_3d_resorted(i,j,k) = values_char_3d(masked_indices(3,k), &
-                                                                      masked_indices(2,j), &
-                                                                      masked_indices(1,i)  )
+                      values_char_3d_resorted(i,j,k) = values_char_3d(masked_indices(3,k),         &
+                                                                      masked_indices(2,j),         &
+                                                                      masked_indices(1,i))
                    ENDDO
                 ENDDO
@@ -1812,12 +1835,11 @@
        ELSEIF ( PRESENT( values_int8_2d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_int8_2d_resorted(0:value_counts(1)-1, &
-                                               0:value_counts(2)-1) )
+             ALLOCATE( values_int8_2d_resorted(0:value_counts(1)-1,0:value_counts(2)-1) )
              !$OMP PARALLEL PRIVATE (i,j)
              !$OMP DO
              DO  i = 0, value_counts(1) - 1
                 DO  j = 0, value_counts(2) - 1
-                   values_int8_2d_resorted(i,j) = values_int8_2d(masked_indices(2,j), &
-                                                                 masked_indices(1,i)  )
+                   values_int8_2d_resorted(i,j) = values_int8_2d(masked_indices(2,j),              &
+                                                                 masked_indices(1,i))
                 ENDDO
              ENDDO
@@ -1830,6 +1852,6 @@
        ELSEIF ( PRESENT( values_int8_3d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_int8_3d_resorted(0:value_counts(1)-1, &
-                                               0:value_counts(2)-1, &
+             ALLOCATE( values_int8_3d_resorted(0:value_counts(1)-1,                                &
+                                               0:value_counts(2)-1,                                &
                                                0:value_counts(3)-1) )
              !$OMP PARALLEL PRIVATE (i,j,k)
@@ -1838,6 +1860,6 @@
                 DO  j = 0, value_counts(2) - 1
                    DO  k = 0, value_counts(3) - 1
-                      values_int8_3d_resorted(i,j,k) = values_int8_3d(masked_indices(3,k), &
-                                                                      masked_indices(2,j), &
+                      values_int8_3d_resorted(i,j,k) = values_int8_3d(masked_indices(3,k),         &
+                                                                      masked_indices(2,j),         &
                                                                       masked_indices(1,i)  )
                    ENDDO
@@ -1870,11 +1892,10 @@
        ELSEIF ( PRESENT( values_int16_2d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_int16_2d_resorted(0:value_counts(1)-1, &
-                                                0:value_counts(2)-1) )
+             ALLOCATE( values_int16_2d_resorted(0:value_counts(1)-1,0:value_counts(2)-1) )
              !$OMP PARALLEL PRIVATE (i,j)
              !$OMP DO
              DO  i = 0, value_counts(1) - 1
                 DO  j = 0, value_counts(2) - 1
-                   values_int16_2d_resorted(i,j) = values_int16_2d(masked_indices(2,j), &
+                   values_int16_2d_resorted(i,j) = values_int16_2d(masked_indices(2,j),            &
                                                                    masked_indices(1,i))
                 ENDDO
@@ -1888,6 +1909,6 @@
        ELSEIF ( PRESENT( values_int16_3d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_int16_3d_resorted(0:value_counts(1)-1, &
-                                                0:value_counts(2)-1, &
+             ALLOCATE( values_int16_3d_resorted(0:value_counts(1)-1,                               &
+                                                0:value_counts(2)-1,                               &
                                                 0:value_counts(3)-1) )
              !$OMP PARALLEL PRIVATE (i,j,k)
@@ -1896,7 +1917,7 @@
                 DO  j = 0, value_counts(2) - 1
                    DO  k = 0, value_counts(3) - 1
-                      values_int16_3d_resorted(i,j,k) = values_int16_3d(masked_indices(3,k), &
-                                                                        masked_indices(2,j), &
-                                                                        masked_indices(1,i)  )
+                      values_int16_3d_resorted(i,j,k) = values_int16_3d(masked_indices(3,k),       &
+                                                                        masked_indices(2,j),       &
+                                                                        masked_indices(1,i))
                    ENDDO
                 ENDDO
@@ -1928,12 +1949,11 @@
        ELSEIF ( PRESENT( values_int32_2d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_int32_2d_resorted(0:value_counts(1)-1, &
-                                                0:value_counts(2)-1) )
+             ALLOCATE( values_int32_2d_resorted(0:value_counts(1)-1,0:value_counts(2)-1) )
              !$OMP PARALLEL PRIVATE (i,j)
              !$OMP DO
              DO  i = 0, value_counts(1) - 1
                 DO  j = 0, value_counts(2) - 1
-                   values_int32_2d_resorted(i,j) = values_int32_2d(masked_indices(2,j), &
-                                                                   masked_indices(1,i)  )
+                   values_int32_2d_resorted(i,j) = values_int32_2d(masked_indices(2,j),            &
+                                                                   masked_indices(1,i))
                 ENDDO
              ENDDO
@@ -1946,6 +1966,6 @@
        ELSEIF ( PRESENT( values_int32_3d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_int32_3d_resorted(0:value_counts(1)-1, &
-                                                0:value_counts(2)-1, &
+             ALLOCATE( values_int32_3d_resorted(0:value_counts(1)-1,                               &
+                                                0:value_counts(2)-1,                               &
                                                 0:value_counts(3)-1) )
              !$OMP PARALLEL PRIVATE (i,j,k)
@@ -1954,7 +1974,7 @@
                 DO  j = 0, value_counts(2) - 1
                    DO  k = 0, value_counts(3) - 1
-                      values_int32_3d_resorted(i,j,k) = values_int32_3d(masked_indices(3,k), &
-                                                                        masked_indices(2,j), &
-                                                                        masked_indices(1,i)  )
+                      values_int32_3d_resorted(i,j,k) = values_int32_3d(masked_indices(3,k),       &
+                                                                        masked_indices(2,j),       &
+                                                                        masked_indices(1,i))
                    ENDDO
                 ENDDO
@@ -1967,5 +1987,5 @@
           values_int32_3d_pointer => values_int32_3d_resorted
 !
-!--    working-precision integer output
+!--    Working-precision integer output
        ELSEIF ( PRESENT( values_intwp_0d ) )  THEN
           values_intwp_0d_pointer => values_intwp_0d
@@ -1986,12 +2006,11 @@
        ELSEIF ( PRESENT( values_intwp_2d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_intwp_2d_resorted(0:value_counts(1)-1, &
-                                                0:value_counts(2)-1) )
+             ALLOCATE( values_intwp_2d_resorted(0:value_counts(1)-1,0:value_counts(2)-1) )
              !$OMP PARALLEL PRIVATE (i,j)
              !$OMP DO
              DO  i = 0, value_counts(1) - 1
                 DO  j = 0, value_counts(2) - 1
-                   values_intwp_2d_resorted(i,j) = values_intwp_2d(masked_indices(2,j), &
-                                                                   masked_indices(1,i)  )
+                   values_intwp_2d_resorted(i,j) = values_intwp_2d(masked_indices(2,j),            &
+                                                                   masked_indices(1,i))
                 ENDDO
              ENDDO
@@ -2004,6 +2023,6 @@
        ELSEIF ( PRESENT( values_intwp_3d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_intwp_3d_resorted(0:value_counts(1)-1, &
-                                                0:value_counts(2)-1, &
+             ALLOCATE( values_intwp_3d_resorted(0:value_counts(1)-1,                               &
+                                                0:value_counts(2)-1,                               &
                                                 0:value_counts(3)-1) )
              !$OMP PARALLEL PRIVATE (i,j,k)
@@ -2012,7 +2031,7 @@
                 DO  j = 0, value_counts(2) - 1
                    DO  k = 0, value_counts(3) - 1
-                      values_intwp_3d_resorted(i,j,k) = values_intwp_3d(masked_indices(3,k), &
-                                                                        masked_indices(2,j), &
-                                                                        masked_indices(1,i)  )
+                      values_intwp_3d_resorted(i,j,k) = values_intwp_3d(masked_indices(3,k),       &
+                                                                        masked_indices(2,j),       &
+                                                                        masked_indices(1,i))
                    ENDDO
                 ENDDO
@@ -2044,12 +2063,11 @@
        ELSEIF ( PRESENT( values_real32_2d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_real32_2d_resorted(0:value_counts(1)-1, &
-                                                 0:value_counts(2)-1) )
+             ALLOCATE( values_real32_2d_resorted(0:value_counts(1)-1,0:value_counts(2)-1) )
              !$OMP PARALLEL PRIVATE (i,j)
              !$OMP DO
              DO  i = 0, value_counts(1) - 1
                 DO  j = 0, value_counts(2) - 1
-                   values_real32_2d_resorted(i,j) = values_real32_2d(masked_indices(2,j), &
-                                                                     masked_indices(1,i)  )
+                   values_real32_2d_resorted(i,j) = values_real32_2d(masked_indices(2,j),          &
+                                                                     masked_indices(1,i))
                 ENDDO
              ENDDO
@@ -2062,6 +2080,6 @@
        ELSEIF ( PRESENT( values_real32_3d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_real32_3d_resorted(0:value_counts(1)-1, &
-                                                 0:value_counts(2)-1, &
+             ALLOCATE( values_real32_3d_resorted(0:value_counts(1)-1,                              &
+                                                 0:value_counts(2)-1,                              &
                                                  0:value_counts(3)-1) )
              !$OMP PARALLEL PRIVATE (i,j,k)
@@ -2070,7 +2088,7 @@
                 DO  j = 0, value_counts(2) - 1
                    DO  k = 0, value_counts(3) - 1
-                      values_real32_3d_resorted(i,j,k) = values_real32_3d(masked_indices(3,k), &
-                                                                          masked_indices(2,j), &
-                                                                          masked_indices(1,i)  )
+                      values_real32_3d_resorted(i,j,k) = values_real32_3d(masked_indices(3,k),     &
+                                                                          masked_indices(2,j),     &
+                                                                          masked_indices(1,i))
                    ENDDO
                 ENDDO
@@ -2102,12 +2120,11 @@
        ELSEIF ( PRESENT( values_real64_2d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_real64_2d_resorted(0:value_counts(1)-1, &
-                                                 0:value_counts(2)-1) )
+             ALLOCATE( values_real64_2d_resorted(0:value_counts(1)-1,0:value_counts(2)-1) )
              !$OMP PARALLEL PRIVATE (i,j)
              !$OMP DO
              DO  i = 0, value_counts(1) - 1
                 DO  j = 0, value_counts(2) - 1
-                   values_real64_2d_resorted(i,j) = values_real64_2d(masked_indices(2,j), &
-                                                                     masked_indices(1,i)  )
+                   values_real64_2d_resorted(i,j) = values_real64_2d(masked_indices(2,j),          &
+                                                                     masked_indices(1,i))
                 ENDDO
              ENDDO
@@ -2120,6 +2137,6 @@
        ELSEIF ( PRESENT( values_real64_3d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_real64_3d_resorted(0:value_counts(1)-1, &
-                                                 0:value_counts(2)-1, &
+             ALLOCATE( values_real64_3d_resorted(0:value_counts(1)-1,                              &
+                                                 0:value_counts(2)-1,                              &
                                                  0:value_counts(3)-1) )
              !$OMP PARALLEL PRIVATE (i,j,k)
@@ -2128,7 +2145,7 @@
                 DO  j = 0, value_counts(2) - 1
                    DO  k = 0, value_counts(3) - 1
-                      values_real64_3d_resorted(i,j,k) = values_real64_3d(masked_indices(3,k), &
-                                                                          masked_indices(2,j), &
-                                                                          masked_indices(1,i)  )
+                      values_real64_3d_resorted(i,j,k) = values_real64_3d(masked_indices(3,k),     &
+                                                                          masked_indices(2,j),     &
+                                                                          masked_indices(1,i))
                    ENDDO
                 ENDDO
@@ -2141,5 +2158,5 @@
           values_real64_3d_pointer => values_real64_3d_resorted
 !
-!--    working-precision real output
+!--    Working-precision real output
        ELSEIF ( PRESENT( values_realwp_0d ) )  THEN
           values_realwp_0d_pointer => values_realwp_0d
@@ -2160,12 +2177,11 @@
        ELSEIF ( PRESENT( values_realwp_2d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_realwp_2d_resorted(0:value_counts(1)-1, &
-                                                 0:value_counts(2)-1) )
+             ALLOCATE( values_realwp_2d_resorted(0:value_counts(1)-1,0:value_counts(2)-1) )
              !$OMP PARALLEL PRIVATE (i,j)
              !$OMP DO
              DO  i = 0, value_counts(1) - 1
                 DO  j = 0, value_counts(2) - 1
-                   values_realwp_2d_resorted(i,j) = values_realwp_2d(masked_indices(2,j), &
-                                                                     masked_indices(1,i)  )
+                   values_realwp_2d_resorted(i,j) = values_realwp_2d(masked_indices(2,j),          &
+                                                                     masked_indices(1,i))
                 ENDDO
              ENDDO
@@ -2178,6 +2194,6 @@
        ELSEIF ( PRESENT( values_realwp_3d ) )  THEN
           IF ( do_output ) THEN
-             ALLOCATE( values_realwp_3d_resorted(0:value_counts(1)-1, &
-                                                 0:value_counts(2)-1, &
+             ALLOCATE( values_realwp_3d_resorted(0:value_counts(1)-1,                              &
+                                                 0:value_counts(2)-1,                              &
                                                  0:value_counts(3)-1) )
              !$OMP PARALLEL PRIVATE (i,j,k)
@@ -2186,7 +2202,7 @@
                 DO  j = 0, value_counts(2) - 1
                    DO  k = 0, value_counts(3) - 1
-                      values_realwp_3d_resorted(i,j,k) = values_realwp_3d(masked_indices(3,k), &
-                                                                          masked_indices(2,j), &
-                                                                          masked_indices(1,i)  )
+                      values_realwp_3d_resorted(i,j,k) = values_realwp_3d(masked_indices(3,k),     &
+                                                                          masked_indices(2,j),     &
+                                                                          masked_indices(1,i))
                    ENDDO
                 ENDDO
@@ -2201,7 +2217,7 @@
        ELSE
           return_value = 1
-          CALL internal_message( 'error', routine_name //                  &
-                                 ': no output values given ' //            &
-                                 '(variable "' // TRIM( variable_name ) // &
+          CALL internal_message( 'error', routine_name //                                          &
+                                 ': no output values given ' //                                    &
+                                 '(variable "' // TRIM( variable_name ) //                         &
                                  '", file "' // TRIM( file_name ) // '")!'  )
        ENDIF
